#include "StdAfx.h"
#include "FormBladeSetupDlg.h"

namespace AudioFixLite {

void FormBladeSetupDlg::SetupCbx(ComboBox^ cbx, std::vector<TValueTable> *table) {
	cbx->Items->Clear();
	for (size_t i = 0; i < table->size(); i++) {
		cbx->Items->Add(gcnew String(table->at(i).m_name.c_str()));
	}
}

void FormBladeSetupDlg::SetCbxValue(ComboBox^ cbx, std::vector<TValueTable> *table, int value) {
	for (size_t i = 0; i < table->size(); i++) {
		if (table->at(i).m_value == value) {
			cbx->Text = gcnew String(table->at(i).m_name.c_str());
			break;
		}
	}
}

void FormBladeSetupDlg::SetCbxValue(ComboBox^ cbx, int value) {
	cbx->Text = Int32(value).ToString();
}

int FormBladeSetupDlg::GetCbxValue(ComboBox^ cbx, std::vector<TValueTable> *table) {
	for (size_t i = 0; i < table->size(); i++) {
		String^ name = gcnew String(table->at(i).m_name.c_str());
		if (cbx->Text == name) {
			return table->at(i).m_value;
			break;
		}
	}
	return 0;
}

int FormBladeSetupDlg::GetCbxValue(ComboBox^ cbx) {
	return Int32::Parse(cbx->Text);
}

System::Void FormBladeSetupDlg::FormBladeSetupDlg_Load(System::Object^  sender, System::EventArgs^  e) {
	SetupCbx(cbEncodeMethod, &m_valueTables->m_encodeMethods);
	SetupCbx(cbMode, &m_valueTables->m_mode);
	SetupCbx(cbVBRQuality, &m_valueTables->m_vbrQuality);
	SetupCbx(cbMinBitrate, &m_valueTables->m_bitrate);
	SetupCbx(cbMaxBitrate, &m_valueTables->m_bitrate);
	SetupCbx(cbABRBitrate, &m_valueTables->m_bitrate);
	SetCbxValue(cbEncodeMethod, &m_valueTables->m_encodeMethods, m_beConfig->format.LHV1.nVbrMethod);
	SetCbxValue(cbMode, &m_valueTables->m_mode, m_beConfig->format.LHV1.nMode);
	SetCbxValue(cbVBRQuality, &m_valueTables->m_vbrQuality, m_beConfig->format.LHV1.nVBRQuality);
	SetCbxValue(cbMinBitrate, m_beConfig->format.LHV1.dwBitrate);
	SetCbxValue(cbMaxBitrate, m_beConfig->format.LHV1.dwMaxBitrate);
	SetCbxValue(cbABRBitrate, m_beConfig->format.LHV1.dwVbrAbr_bps / 1000);
}

System::Void FormBladeSetupDlg::btnOK_Click(System::Object^  sender, System::EventArgs^  e) {
	m_beConfig->format.LHV1.nVbrMethod = (VBRMETHOD)GetCbxValue(cbEncodeMethod, &m_valueTables->m_encodeMethods);
	m_beConfig->format.LHV1.nMode = GetCbxValue(cbMode, &m_valueTables->m_mode);
	m_beConfig->format.LHV1.nVBRQuality = GetCbxValue(cbVBRQuality, &m_valueTables->m_vbrQuality);
	m_beConfig->format.LHV1.dwBitrate = GetCbxValue(cbMinBitrate);
	m_beConfig->format.LHV1.dwMaxBitrate = GetCbxValue(cbMaxBitrate);
	m_beConfig->format.LHV1.dwVbrAbr_bps = GetCbxValue(cbABRBitrate) * 1000;
}

};	// namespace
