#include "StdAfx.h"
#include "FormSimpleLameSetupDlg.h"
//#include "TLameEncoder.h"

namespace AudioFixLite {

void FormSimpleLameSetupDlg::SetupCbx(ComboBox^ cbx, std::vector<TValueTable> *table) {
	cbx->Items->Clear();
	for (size_t i = 0; i < table->size(); i++) {
		cbx->Items->Add(gcnew String(table->at(i).m_name.c_str()));
	}
}

void FormSimpleLameSetupDlg::SetCbxValue(ComboBox^ cbx, std::vector<TValueTable> *table, int value) {
	for (size_t i = 0; i < table->size(); i++) {
		if (table->at(i).m_value == value) {
			cbx->Text = gcnew String(table->at(i).m_name.c_str());
			break;
		}
	}
}

void FormSimpleLameSetupDlg::SetCbxValue(ComboBox^ cbx, int value) {
	cbx->Text = Int32(value).ToString();
}

int FormSimpleLameSetupDlg::GetCbxValue(ComboBox^ cbx, std::vector<TValueTable> *table) {
	for (size_t i = 0; i < table->size(); i++) {
		String^ name = gcnew String(table->at(i).m_name.c_str());
		if (cbx->Text == name) {
			return table->at(i).m_value;
			break;
		}
	}
	return 0;
}

int FormSimpleLameSetupDlg::GetCbxValue(String^ valueStr, std::vector<TValueTable> *table) {
	for (size_t i = 0; i < table->size(); i++) {
		String^ name = gcnew String(table->at(i).m_name.c_str());
		if (valueStr == name) {
			return table->at(i).m_value;
			break;
		}
	}
	return 0;
}

int FormSimpleLameSetupDlg::GetCbxValue(ComboBox^ cbx) {
	return Int32::Parse(cbx->Text);
}

System::Void FormSimpleLameSetupDlg::FormSimpleLameSetupDlg_Load(System::Object^  sender, System::EventArgs^  e) {
	SetupCbx(cbMode, &m_valueTables->m_mode);
	SetupCbx(cbBitrate, &m_valueTables->m_bitrate);
	SetCbxValue(cbMode, &m_valueTables->m_mode, m_beConfig->format.LHV1.nMode);
	SetCbxValue(cbBitrate, m_beConfig->format.LHV1.dwBitrate);
}

System::Void FormSimpleLameSetupDlg::btnOK_Click(System::Object^  sender, System::EventArgs^  e) {
	m_beConfig->format.LHV1.nVbrMethod = (VBRMETHOD)GetCbxValue(_T("CBR"), &m_valueTables->m_encodeMethods);
	m_beConfig->format.LHV1.nMode = GetCbxValue(cbMode, &m_valueTables->m_mode);
	m_beConfig->format.LHV1.nVBRQuality = GetCbxValue(_T("High"), &m_valueTables->m_vbrQuality);
	m_beConfig->format.LHV1.dwBitrate = GetCbxValue(cbBitrate);
	m_beConfig->format.LHV1.dwMaxBitrate = GetCbxValue(cbBitrate);
	m_beConfig->format.LHV1.dwVbrAbr_bps = GetCbxValue(cbBitrate) * 1000;
}

};	// namespace

