#ifndef _TACMENCODER_H_
#define _TACMENCODER_H_

#include "TEncoderBase.h"

#define ENCODER_NAME_ACM		"ACM"

class TACMEncoder : public TEncoderBase {
protected:
	MPEGLAYER3WAVEFORMAT m_fmt;
	bool m_modify;
	void Load();
	void Save();
	std::wstring GetSaveFilePath();
public:
	virtual bool Init(TAudioFileProcess *context);
	virtual void Setup(HWND window);
	virtual bool Encode(TAudioFile *af, TFileWriter *fOut, TAudioFilterReader *fIn, TAudioFileFormat *format);
	virtual std::wstring GetName() {
		return _T(ENCODER_NAME_ACM);
	}
	virtual long GetBitrate() {
		return (long)m_fmt.wfx.nAvgBytesPerSec / 125;
	}
	//
	virtual ~TACMEncoder();
};


#endif // _ACMENCODER_H_
