#ifndef _TBLADEENCODER_H_
#define _TBLADEENCODER_H_

#include "TEncoderBase.h"
#include "BladeMP3EncDLL.h"
#include "TTools.h"

class BladeSetupValueTables {
public:
	std::vector<TValueTable> m_encodeMethods;
	std::vector<TValueTable> m_vbrQuality;
	std::vector<TValueTable> m_mode;
	std::vector<TValueTable> m_bitrate;
	BladeSetupValueTables();
};

class TBladeEncoder : public TEncoderBase {
protected:
	BE_CONFIG m_beConfig;
	HINSTANCE m_hDLL;
	BEINITSTREAM		beInitStream;
	BEENCODECHUNK		beEncodeChunk;
	BEDEINITSTREAM		beDeinitStream;
	BECLOSESTREAM		beCloseStream;
	BEVERSION			beVersion;
	BEWRITEVBRHEADER	beWriteVBRHeader;
	BEWRITEINFOTAG		beWriteInfoTag;

	BladeSetupValueTables m_valueTables;
	bool m_modify;
	HBE_STREAM m_hbeStream;
	void Load();
	void Save();
	std::wstring GetSaveFilePath();
public:
	virtual bool Init(TAudioFileProcess *context);
	virtual void Setup(HWND window);
	void ValidateConfig();
	virtual bool Encode(TAudioFile *af, TFileWriter *fOut, TAudioFilterReader *fIn, TAudioFileFormat *format);
	virtual bool IsNeedPostEncode() {
		return (m_beConfig.format.LHV1.bWriteVBRHeader != FALSE);
	}
	virtual bool PostEncode(const char *path);
	virtual std::wstring GetName() {
		return _T("LAME");
	}
	virtual long GetBitrate() {
		return (long)m_beConfig.format.LHV1.dwBitrate;
	}
	virtual bool IsNull() {
		return m_hDLL == NULL;
	}
	//
	TBladeEncoder();
	virtual ~TBladeEncoder();
};


#endif // _LAMEENCODER_H_
