#ifndef _NENCODERBASE_H_
#define _NENCODERBASE_H_

#include "TFileIO.h"

#if USE_UNMANAGED
#pragma managed(push, off)
#endif

class TAudioFile;
class TAudioFilterReader;
class TAudioFileFormat;
class TAudioFileProcess;
class TEncoderBase;

class TEncoderBase {
protected:
	TAudioFileProcess *m_context;
	bool m_enable;
public:
	TEncoderBase() {
	}
	virtual ~TEncoderBase() {
	}
	virtual bool Init(TAudioFileProcess *context) {
		m_context = context;
		return true;
	}
	virtual void Setup(HWND window) {
	}
	virtual bool Encode(TAudioFile *af, TFileWriter *fOut, TAudioFilterReader *fpIn, TAudioFileFormat *format) = 0;
	virtual bool IsNeedPostEncode() {
		return false;
	}
	virtual bool PostEncode(const char *path) {
		return true;
	}
	virtual bool IsEnable() {
		return m_enable;
	}
	virtual std::wstring GetName() {
		return _T("");
	}
	virtual long GetBitrate() {
		return 0;
	}
	virtual bool IsNull() {
		return false;
	}
};

#if USE_UNMANAGED
#pragma managed(pop)
#endif

#endif // _ENCODERBASE_H_
