#include "stdafx.h"
#include "TGlobal.h"
#include "TGainFilter.h"
#include <math.h>

#pragma managed(push, off)

void TGainFilter::Init() {
	m_db = 0.0;
	m_magnif = 0.0;
	m_maxLogicalValue = 0.0;
	m_minLogicalValue = 0.0;
	m_bits = 0;
}

TGainFilter::TGainFilter() {
	Init();
}

TGainFilter::TGainFilter(int bits, double db) {
	Init();
	Setup(bits, db);
}

double TGainFilter::Setup(int bits, double db) {
	m_bits = bits;
	m_maxLogicalValue = pow((double)2.0, m_bits - 1) - 1.0;
	m_minLogicalValue = -pow((double)2.0, m_bits - 1);
	m_maxLogicalDecibel = log10(pow((double)2.0, m_bits - 1));
	m_db = db;
	m_magnif = pow(10, db / 20.0);
	return m_magnif;
}

/*
	Tvliƕ̐jfVxi0ȉjɂ
*/
double TGainFilter::SampleToDecibel(long x) {
	if (x < 0)
		x = -x;
	return -20.0 * (m_maxLogicalDecibel - log10((double)x + 1.0));
}

double TGainFilter::ChangeGainDouble(double inData) {
	return inData * m_magnif;
}

long TGainFilter::ChangeGainLong(long inData) {
	double v = ChangeGainDouble((double)inData);
	if (v > m_maxLogicalValue)
		return (long)m_maxLogicalValue;
	else if (v < m_minLogicalValue)
		return (long)m_minLogicalValue;
	return (long)v;
}

double TGainFilter::MonoDouble(double inData1, double inData2) {
	return (inData1 + inData2) / 2;
}

long TGainFilter::MonoLong(long inData1, long inData2) {
	return (long)MonoDouble((double)inData1, (double)inData2);
}

#pragma managed(pop)

