#ifndef _TLAMELIB_H_
#define _TLAMELIB_H_

#include "lame.h"
#include <string>

#pragma managed(push, off)

typedef lame_global_flags *(CDECL *LAME_INIT)(void);
#define	T_LAME_INIT	"lame_init"
typedef int	(CDECL *LAME_INIT_PARAMS)(lame_global_flags * const);
#define	T_LAME_INIT_PARAMS	"lame_init_params"
typedef int	(CDECL *LAME_CLOSE)(lame_global_flags *);
#define	T_LAME_CLOSE	"lame_close"
typedef int	(CDECL *LAME_ENCODE_BUFFER)(lame_global_flags *, const short int *, const short int *, const int, unsigned char *, const int);
#define	T_LAME_ENCODE_BUFFER	"lame_encode_buffer"
typedef int	(CDECL *LAME_ENCODE_BUFFER_INTERLEAVED)(lame_global_flags *, short int *, int, unsigned char *, int);
#define	T_LAME_ENCODE_BUFFER_INTERLEAVED	"lame_encode_buffer_interleaved"
typedef int	(CDECL *LAME_ENCODE_FLUSH)(lame_global_flags *, unsigned char *, int);
#define	T_LAME_ENCODE_FLUSH	"lame_encode_flush"
typedef int	(CDECL *LAME_MP3_TAGS_FID)(lame_global_flags *, FILE *);
#define	T_LAME_MP3_TAGS_FID	"lame_mp3_tags_fid"
typedef int	(CDECL *LAME_INIT_BITSTREAM)(lame_global_flags *);
#define	T_LAME_INIT_BITSTREAM	"lame_init_bitstream"
typedef char *(CDECL *GET_LAME_VERSION)(void);
#define	T_GET_LAME_VERSION	"get_lame_version"
typedef char *(CDECL *GET_LAME_VERSION_NUMERICAL)(lame_version_t *const);
#define	T_GET_LAME_VERSION_NUMERICAL	"get_lame_version_numerical"

const char*  CDECL get_lame_version       ( void );

typedef int	(CDECL *LAME_SET_INT)(lame_global_flags *, int);
typedef int	(CDECL *LAME_GET_INT)(const lame_global_flags *);

class TLameLib {
public:
	HINSTANCE m_hDLL;
	//
	LAME_INIT lame_init;
	LAME_INIT_PARAMS lame_init_params;
	LAME_CLOSE lame_close;
	LAME_ENCODE_BUFFER lame_encode_buffer;
	LAME_ENCODE_BUFFER_INTERLEAVED lame_encode_buffer_interleaved;
	LAME_ENCODE_FLUSH lame_encode_flush;
	LAME_MP3_TAGS_FID lame_mp3_tags_fid;
	LAME_INIT_BITSTREAM lame_init_bitstream;
	GET_LAME_VERSION get_lame_version;
	GET_LAME_VERSION_NUMERICAL get_lame_version_numerical;

	TLameLib() {
		m_hDLL = NULL;
	}

	virtual ~TLameLib() {
		if (m_hDLL != NULL) {
			FreeLibrary(m_hDLL);
		}
	}

	bool IsNull() {
		return m_hDLL == NULL;
	}

	bool Init() {
		m_hDLL = LoadLibrary(_T("lame_enc.dll"));
  		if (m_hDLL == NULL) {
  			return false;
  		}
		lame_init = (LAME_INIT)GetProcAddress(m_hDLL, T_LAME_INIT);
		lame_init_params = (LAME_INIT_PARAMS)GetProcAddress(m_hDLL, T_LAME_INIT_PARAMS);
		lame_close = (LAME_CLOSE)GetProcAddress(m_hDLL, T_LAME_CLOSE);
		lame_encode_buffer = (LAME_ENCODE_BUFFER)GetProcAddress(m_hDLL, T_LAME_ENCODE_BUFFER);
		lame_encode_buffer_interleaved = (LAME_ENCODE_BUFFER_INTERLEAVED)GetProcAddress(m_hDLL, T_LAME_ENCODE_BUFFER_INTERLEAVED);
		lame_encode_flush = (LAME_ENCODE_FLUSH)GetProcAddress(m_hDLL, T_LAME_ENCODE_FLUSH);
		lame_mp3_tags_fid = (LAME_MP3_TAGS_FID)GetProcAddress(m_hDLL, T_LAME_MP3_TAGS_FID);
		lame_init_bitstream = (LAME_INIT_BITSTREAM)GetProcAddress(m_hDLL, T_LAME_INIT_BITSTREAM);
		get_lame_version = (GET_LAME_VERSION)GetProcAddress(m_hDLL, T_GET_LAME_VERSION);
		get_lame_version_numerical = (GET_LAME_VERSION_NUMERICAL)GetProcAddress(m_hDLL, T_GET_LAME_VERSION_NUMERICAL);
		return true;
	}

	// GetProcAddressŎȂ֐ɑB
	// ̐헪łLAME͎gȂ悤BB

	int lame_set_int_prop(lame_global_flags *lgf, const char *propName, int value) {
		std::string funcName("lame_set_");
		funcName += propName;
		LAME_SET_INT func = (LAME_SET_INT)GetProcAddress(m_hDLL, funcName.c_str());
		if (func != NULL) {
			return func(lgf, value);
		}
		else {
			return -1;
		}
	}

	int lame_get_int_prop(lame_global_flags *lgf, const char *propName) {
		std::string funcName("lame_get_");
		funcName += propName;
		LAME_GET_INT func = (LAME_GET_INT)GetProcAddress(m_hDLL, funcName.c_str());
		if (func != NULL)
			return func(lgf);
		return -1;
	}
};

#pragma managed(pop)

#endif	// _TLAMELIB_H_
