#include "stdafx.h"
#include "TGlobal.h"
#include "TACMEncoder.h"

Preferences::Preferences() {
}

List<int>^ Preferences::GetColumnWidth() {
	List<int>^ list = gcnew List<int>;
	list->Add(statusW);
	list->Add(artistW);
	list->Add(albumW);
	list->Add(waveW);
	list->Add(gainW);
	list->Add(maxDecibelW);
	list->Add(maxSamplePosW);
	list->Add(laudDecibelW);
	list->Add(phaseGapW);
	list->Add(movePhaseW);
	list->Add(clickNoiseCountW);
	list->Add(repairClickNoiseW);
	list->Add(averageW);
	list->Add(moveDcOffsetW);
	list->Add(hzW);
	list->Add(bitsW);
	list->Add(chW);
	list->Add(timeW);
	list->Add(mp3W);
	return list;
}

void Preferences::SetColumnWidth(List<int>^ list) {
	int i = 0;
	statusW = list[i++];
	artistW = list[i++];
	albumW = list[i++];
	waveW = list[i++];
	gainW = list[i++];
	maxDecibelW = list[i++];
	maxSamplePosW = list[i++];
	laudDecibelW = list[i++];
	phaseGapW = list[i++];
	movePhaseW = list[i++];
	clickNoiseCountW = list[i++];
	repairClickNoiseW = list[i++];
	averageW = list[i++];
	moveDcOffsetW = list[i++];
	hzW = list[i++];
	bitsW = list[i++];
	chW = list[i++];
	timeW = list[i++];
	mp3W = list[i++];
}

String^ Preferences::GetPrefDirPath() {
	String^ prefDirPath = System::Environment::GetFolderPath(Environment::SpecialFolder::ApplicationData) + _T("\\OSTRA\\");
	if (!Directory::Exists(prefDirPath)) {
		Directory::CreateDirectory(prefDirPath);
	}
	return prefDirPath;
}

String^ Preferences::GetPrefFilePath() {
	String^ path = GetPrefDirPath() + _T("AudioFixLite_2_0.pref");
	return path;
}

bool Preferences::Save() {
	version = CURRENT_PREF_VERSION;
	XmlSerializer ^serializer = gcnew XmlSerializer(Preferences::typeid);
	FileStream ^fs = gcnew FileStream(GetPrefFilePath(), FileMode::Create);
	if (fs == nullptr) {
		return false;
	}
	serializer->Serialize(fs, this);
	fs->Close();
	return true;
}

Preferences^ Preferences::Load() {
	Preferences ^result = nullptr;
	XmlSerializer ^serializer = gcnew XmlSerializer(Preferences::typeid);
	FileStream ^fs = nullptr;
	try {
		fs = gcnew FileStream(GetPrefFilePath(), FileMode::Open);
	}
	catch (Exception^) {
		fs = nullptr;
	}
	if (fs != nullptr) {
		try {
			result = (Preferences^)serializer->Deserialize(fs);
		}
		catch (Exception^) {
		}
		fs->Close();
	}
	if (result == nullptr) {
		result = gcnew Preferences;
	}
	result->version = CURRENT_PREF_VERSION;
	return result;
}

Font^ Preferences::GetDialogFont() {
	if (applyFontToDialog) {
		return gcnew Font(fontFamily, fontSize);
	}
	else {
		return System::Drawing::SystemFonts::MessageBoxFont;
	}
}
