#include "stdafx.h"
#include "TWaveFileReader.h"

#pragma managed(push, off)

void TWaveFileReader::Init() {
	m_format = NULL;
	m_sampleBytes = 0;
	m_fIn = NULL;
}

TWaveFileReader::TWaveFileReader() {
	Init();
}

TWaveFileReader::TWaveFileReader(const std::wstring &path, TAudioFileFormat *format) {
	Init();
	Open(path, format);
}

TWaveFileReader::~TWaveFileReader() {
	if (m_fIn != NULL)
		delete m_fIn;
}

bool TWaveFileReader::Open(const std::wstring &path, TAudioFileFormat *format) {
	m_fIn = new TFileReader(path);
	if (m_fIn->IsOK() == false) {
		return false;
	}
	m_format = format;
	m_sampleBytes = BitsToBytes(m_format->m_waveFormat.wBitsPerSample);
	m_fIn->Seek(m_format->m_dataPos, SEEK_SET);
	return true;
}

long TWaveFileReader::GetSample(int ch, long frame) {
//	if (frame == (65536/2)) {
//int x = 0;
//	}
	long pos = frame * m_sampleBytes * m_format->m_waveFormat.nChannels + ch * m_sampleBytes;
	if (pos < 0 || m_format->m_dataPos + pos >= m_fIn->GetFileSize())
		return 0;
	m_fIn->Seek(m_format->m_dataPos + pos, SEEK_SET);
	BYTE raw[sizeof(long)];
	m_fIn->Read(raw, m_sampleBytes);
	long sample = SampleRawToLong(raw, m_sampleBytes, m_format->m_bigEndian);
	return sample;
}

bool TWaveFileReader::IsOK() {
	return m_fIn != NULL && m_fIn->IsOK();
}

#pragma managed(pop)
