#ifndef _TWAVEFILEREADER_H_
#define _TWAVEFILEREADER_H_

#include "TAudioFIleFormat.h"
#include "TFileIO.h"

#pragma managed(push, off)

class TWaveFileReader {
protected:
	TAudioFileFormat *m_format;
	int m_sampleBytes;
	TFileReader *m_fIn;
public:
	TWaveFileReader();
	TWaveFileReader(const std::wstring &path, TAudioFileFormat *format);
	~TWaveFileReader();
	void Init();
	bool Open(const std::wstring &path, TAudioFileFormat *format);
	long GetSample(int ch, long frame);
	void Jump(long frame) {
		GetSample(0, frame < 0 ? 0 : frame);
	}
	TAudioFileFormat *GetFormat() const {
		return m_format;
	}
	bool IsOK();
};

#pragma managed(pop)

#endif
